## mctc-lib 0.3.1

=== example/CMakeLists.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.14)

project(
  "mctc-convert"
  LANGUAGES "Fortran"
  VERSION "0.2.3"
  DESCRIPTION "Example project for converting geometry inputs"
)

if(NOT TARGET "mctc-lib::mctc-lib")
  find_package("mctc-lib")
endif()

add_executable(
  "${PROJECT_NAME}"
  "../app/main.f90"
)
target_link_libraries(
  "${PROJECT_NAME}"
  PRIVATE
  "mctc-lib::mctc-lib"
)

install(
  TARGETS
  "${PROJECT_NAME}"
  DESTINATION
  "${CMAKE_INSTALL_BINDIR}"
)

=== test/CMakeLists.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Unit testing
set(
  tests
  "math"
  "read"
  "read-aims"
  "read-cjson"
  "read-ctfile"
  "read-gaussian"
  "read-genformat"
  "read-pdb"
  "read-qchem"
  "read-qcschema"
  "read-turbomole"
  "read-vasp"
  "read-xyz"
  "symbols"
  "write"
  "write-aims"
  "write-cjson"
  "write-ctfile"
  "write-gaussian"
  "write-genformat"
  "write-pdb"
  "write-qchem"
  "write-turbomole"
  "write-vasp"
  "write-xyz"
)
set(
  test-srcs
  "main.f90"
  "testsuite_structure.f90"
)
foreach(t IN LISTS tests)
  string(MAKE_C_IDENTIFIER ${t} t) 
  list(APPEND test-srcs "test_${t}.f90")
endforeach()

add_executable(
  "${PROJECT_NAME}-tester"
  "${test-srcs}"
)
target_link_libraries(
  "${PROJECT_NAME}-tester"
  PRIVATE
  "${PROJECT_NAME}-lib"
)

foreach(t IN LISTS tests)
  add_test("${PROJECT_NAME}/${t}" "${PROJECT_NAME}-tester" "${t}")
endforeach()

=== src/mctc/CMakeLists.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory("env")
add_subdirectory("io")

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/env.f90"
  "${dir}/io.f90"
  "${dir}/version.F90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/mctc/io/read/CMakeLists.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/aims.f90"
  "${dir}/cjson.F90"
  "${dir}/ctfile.f90"
  "${dir}/gaussian.f90"
  "${dir}/genformat.f90"
  "${dir}/qchem.f90"
  "${dir}/qcschema.F90"
  "${dir}/pdb.f90"
  "${dir}/turbomole.f90"
  "${dir}/vasp.f90"
  "${dir}/xyz.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== debian/control ===
Source: mctc-lib
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 gfortran,
 meson,
Standards-Version: 4.6.1
Homepage: https://github.com/grimme-lab/mctc-lib
Vcs-Browser: https://salsa.debian.org/science-team/mctc-lib
Vcs-Git: https://salsa.debian.org/science-team/mctc-lib.git

Package: libmctc-lib-dev
Architecture: any
Section: libdevel
Depends:
 libmctc-lib0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: modular computation tool chain library (development files)
 Common tool chain for working with molecular structure data in various
 applications. This library provides a unified way to perform operations on
 molecular structure data, like reading and writing to common geometry file
 formats.
 .
 This package contains development files.

Package: libmctc-lib0
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: modular computation tool chain library
 Common tool chain for working with molecular structure data in various
 applications. This library provides a unified way to perform operations on
 molecular structure data, like reading and writing to common geometry file
 formats.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem meson

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/v(\d\S+)\.tar\.gz/mctc-lib-$1\.tar\.gz/ https://github.com/grimme-lab/mctc-lib/tags .*\/v(\d\S+)\.tar\.gz

## mctc-lib 0.3.2

=== CMakeLists.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.14)

project(
  "mctc-lib"
  LANGUAGES "Fortran"
  VERSION "0.3.2"
  DESCRIPTION "Modular computation tool chain"
)

# Follow GNU conventions for installing directories
include(GNUInstallDirs)

# General configuration information
add_subdirectory("config")

# Dependencies
if(NOT TARGET "jsonfortran::jsonfortran" AND WITH_JSON)
  find_package("jsonfortran" REQUIRED)
endif()

# Collect source of the project
set(srcs)
add_subdirectory("src")

# MCTC library target
add_library(
  "${PROJECT_NAME}-lib"
  "${srcs}"
)
target_compile_definitions(
  "${PROJECT_NAME}-lib"
  PRIVATE
  "WITH_JSON=$<BOOL:${WITH_JSON}>"
)
if(WITH_OpenMP)
  find_package(OpenMP REQUIRED)
  target_link_libraries(
    "${PROJECT_NAME}-lib"
    PRIVATE
    OpenMP::OpenMP_Fortran
  )
endif()
if(WITH_JSON)
  target_link_libraries(
    "${PROJECT_NAME}-lib"
    PRIVATE
    "jsonfortran::jsonfortran"
  )
endif()
set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "${PROJECT_NAME}"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${PROJECT_BINARY_DIR}/include"
)
target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)
if(NOT EXISTS "${PROJECT_BINARY_DIR}/include")
  file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/include")
endif()

# Add example application
add_subdirectory("app")

# Export targets for other projects
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")
install(
  TARGETS
  "${PROJECT_NAME}"
  "${PROJECT_NAME}-lib"
  EXPORT
  "${PROJECT_NAME}-targets"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)
install(
  EXPORT
  "${PROJECT_NAME}-targets"
  NAMESPACE
  "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  DIRECTORY
  "${PROJECT_BINARY_DIR}/include/"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
)
# Package license files
install(
  FILES
  "LICENSE"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
)

# add the testsuite
enable_testing()
add_subdirectory("test")

=== config/CMakeLists.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

option(BUILD_SHARED_LIBS "Whether the libraries built should be shared" FALSE)

option(WITH_OpenMP "Enable support for shared memory parallelisation with OpenMP" TRUE)
option(WITH_JSON "Enable support for JSON parsing via json-fortran" FALSE)

set(
  "${PROJECT_NAME}-module-dir"
  "${PROJECT_NAME}/modules"
  CACHE STRING
  "Subdirectory to install generated module files to"
)
set(
  module-dir
  "${${PROJECT_NAME}-module-dir}"
)
set(module-dir "${module-dir}" PARENT_SCOPE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" PARENT_SCOPE)
install(
  DIRECTORY
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

# Compiler-specific configurations 
if(
  CMAKE_Fortran_COMPILER_ID MATCHES "PGI"
  OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"
  OR CMAKE_Fortran_COMPILER_ID MATCHES "Flang"
)
  set(
    CMAKE_Fortran_FLAGS
    "${CMAKE_Fortran_FLAGS} -Mbackslash -Mallocatable=03"
    PARENT_SCOPE
  )
endif()

# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION "${PROJECT_VERSION}"
  COMPATIBILITY SameMinorVersion
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

if(BUILD_SHARED_LIBS)
  set(PKG_CONFIG_REQUIRES "Requires.private")
else()
  set(PKG_CONFIG_REQUIRES "Requires")
endif()
if(WITH_JSON)
  set(PKG_CONFIG_REQUIREMENTS "json-fortran")
else()
  set(PKG_CONFIG_REQUIREMENTS)
endif()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.pc"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== src/CMakeLists.txt ===
# This file is part of mctc-lib.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory("mctc")

set(srcs "${srcs}" PARENT_SCOPE)

=== debian/changelog ===
mctc-lib (0.3.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libmctc-lib0: Add Multi-Arch: same.

  [ Andrius Merkys ]
  * New upstream version 0.3.2

 -- Andrius Merkys <merkys@debian.org>  Tue, 10 Sep 2024 07:52:20 -0400

mctc-lib (0.3.1-3) unstable; urgency=medium

  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add debian/watch file, using GitHub.

 -- Andrius Merkys <merkys@debian.org>  Mon, 03 Oct 2022 10:45:26 -0400

mctc-lib (0.3.1-2) unstable; urgency=medium

  * libmctc-lib-dev depends on libmctc-lib0.

 -- Andrius Merkys <merkys@debian.org>  Thu, 22 Sep 2022 01:38:38 -0400

mctc-lib (0.3.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1019958)

 -- Andrius Merkys <merkys@debian.org>  Sat, 17 Sep 2022 01:32:13 -0400

=== debian/control ===
--- 
+++ 
@@ -35,6 +35,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+Multi-Arch: same
 Description: modular computation tool chain library
  Common tool chain for working with molecular structure data in various
  applications. This library provides a unified way to perform operations on
